<?php
namespace Teknisa\FIS\Modules\Acessorias\Services;

use Teknisa\FIS\Modules\Acessorias\Services\Jobs;

class Agendamento
{

	public static function criaJob($nomeJob, $dataContabAuto, $sequencialJob, $nrorg, $descricao, $arqCallService, $dirphp, $jenkinsPath, $execPath, $periodicidade, $jenkinsCreateItem = null)
    {
        try {

			$requestUri = $_SERVER["REQUEST_URI"];
			///erp/modules/fis/backend/service/index.php/salvarApuracAutomatica"
            if(strpos($requestUri, "modules") == false) {
                $urlServer = 'https://'.$_SERVER["HTTP_HOST"].'//backend/index.php'.$execPath;

            }
            else {
                if(strpos($_SERVER["DOCUMENT_ROOT"], "workfolder") != false) {
                    $threshold = strpos($requestUri, "index.php");
                    $resUri = substr($_SERVER["REQUEST_URI"], 0, $threshold);
                    // "/erp/modules/fis/backend/service/"
                    $urlServer = 'https://'.$_SERVER["HTTP_HOST"].'/workfolder'.$resUri.'index.php'.$execPath;
                    // "https://tainafernandes2.zeedhi.com/workfolder/erp/modules/fis/backend/service/index.php/execVerificaApuracaoAuto"
                }
                else {
                    $threshold = strpos($requestUri, "index.php");
                    $resUri = substr($_SERVER["REQUEST_URI"], 0, $threshold);
                    $urlServer = 'https://'.$_SERVER["HTTP_HOST"].$resUri.'index.php'.$execPath;
                }
            }
          $arqCallService = null;
            if((isset($arqCallService)) && ($arqCallService != null)){
    			$metodo = Jobs::revertDirectory(
                    $dirphp.'/php.exe "'.$arqCallService.'" url="'.$urlServer.'?NRAGENDAMENTO='.$sequencialJob.'&NRORG='.$nrorg.'"'
                );
                
                // "php/php.exe "C:/Teknisa/CallService.php" url="https://tainafernandes2.zeedhi.com/workfolder/erp/modules/fis/backend/service/index.php/execVerificaApuracaoAuto?NRAGENDAMENTO=0000000200&NRORG=1""


                $jenkins = new Jobs($nomeJob, $jenkinsCreateItem, $jenkinsPath);
                /*
                object(Teknisa\FIS\Modules\Acessorias\Services\Jobs)#4149 (11) {
                  ["url_jenkins":"Teknisa\FIS\Modules\Acessorias\Services\Jenkins":private]=>
                  string(33) "https://ci-pebbian.teknisa.cloud/"
                  ["url_create_item":"Teknisa\FIS\Modules\Acessorias\Services\Jenkins":private]=>
                  string(54) "https://ci-pebbian.teknisa.cloud/view/Tudo/createItem?"
                  ["url_config_job":"Teknisa\FIS\Modules\Acessorias\Services\Jenkins":private]=>
                  NULL
                  ["url_delete_job":"Teknisa\FIS\Modules\Acessorias\Services\Jenkins":private]=>
                  string(46) "https://ci-pebbian.teknisa.cloud/job//doDelete"
                  ["name":"Teknisa\FIS\Modules\Acessorias\Services\Jenkins":private]=>
                  string(42) "VERIFICACAO_APURACAO_AUTOMATICA_0000000201"
                  ["type":"Teknisa\FIS\Modules\Acessorias\Services\Jenkins":private]=>
                  NULL
                  ["from":"Teknisa\FIS\Modules\Acessorias\Services\Jenkins":private]=>
                  NULL
                  ["submit":"Teknisa\FIS\Modules\Acessorias\Services\Jenkins":private]=>
                  NULL
                  ["description":"Teknisa\FIS\Modules\Acessorias\Services\Jenkins":private]=>
                  NULL
                  ["method":"Teknisa\FIS\Modules\Acessorias\Services\Jenkins":private]=>
                  NULL
                  ["period":"Teknisa\FIS\Modules\Acessorias\Services\Jenkins":private]=>
                  NULL
                }
                */
                
                $jenkins->setType(Jobs::TYPE_JOB_MULT_CONF);
                $jenkins->setUrlConfig(null);
                // "https://ci-pebbian.teknisa.cloud/job/VERIFICACAO_APURACAO_AUTOMATICA_0000000203/configSubmit"
                $jenkins->setPeriod($jenkins->formatDateToExecute($dataContabAuto, $periodicidade));
                $jenkins->setDescription($descricao);
                $jenkins->setMethod($metodo);
                $jenkins->createJob($jenkinsPath);
              //esse createJob dá erro 
                
                $jenkins->configuration($jenkinsPath);

            } else {
                $metodo = 'curl "'.$urlServer.'?NRAGENDAMENTO='.$sequencialJob.'&NRORG='.$nrorg.'"';
                ///curl "https://tainafernandes2.zeedhi.com/workfolder/erp/modules/fis/backend/service/index.php/execVerificaApuracaoAuto?NRAGENDAMENTO=0000000193&NRORG=1"
             
                $jenkins = new Jobs($nomeJob, $jenkinsCreateItem, $jenkinsPath);
                $jenkins->setType(Jobs::TYPE_JOB_MULT_CONF);
                $jenkins->setUrlConfig(null);
                $jenkins->setperiod($jenkins->formatdatetoexecute($dataContabAuto, $periodicidade));
                $jenkins->setDescription($descricao);
                $jenkins->setMethod($metodo);
                
                $jenkins->createJobLinux($jenkinsPath);
                $jenkins->configurationLinux($jenkinsPath);

            }
            //C:\xampp\php\php.exe "C:\Teknisa\CallService.php" url="https://tainafernandes.zeedhi.com/workfolder/erp/modules/fis/backend/service/index.php/execAgendamento" NRAGENDAMENTO="0000000047" NRORG="2025"

        } catch (\Exception $e) {
            throw new \Exception("Houve um erro ao comunicar com o Jenkins: ".$e->getMessage());
        }
    }

	public static function apagaJob($nomeJob, $createItem, $jenkinsPath, $arqCallService = null)
	{
	    try {
    		$jenkins = new Jobs($nomeJob, $createItem, $jenkinsPath);
    		$jenkins->setUrlDelete($nomeJob);
    		if((isset($arqCallService)) && ($arqCallService != null)){
        		$jenkins->deleteJob();
    		} else {
        		$jenkins->deleteJobLinux($jenkinsPath);
    		}
	    } catch (\Exception $e) {
            throw new \Exception("Houve um erro ao comunicar com o Jenkins: ".$e->getMessage());
        }
	}

}
